#!/usr/bin/env python3
# -*- coding: utf8 -*-

from pathlib import Path
from os import system, rename
from time import sleep
from datetime import datetime, timedelta

home = str(Path.home())
dateYearString = "2019-"
timeZoneString = " +0000"

ipPool = ["80.251.183.146", "141.20.33.234"]
screenSessionName = "22787.pts-0.a7779ae5-dd4b-4c3e-9059-956ebf8d8b6b"


def getStartDate():
    try:
        f = open(home + "/.ethereum/peers.txt", "r")
    except FileNotFoundError:
        return "-1"
    firstline = f.readline()
    dateStartPosition = firstline.find(dateYearString)
    dateEndPosition = firstline.find(timeZoneString)
    fullDate = firstline[dateStartPosition:dateEndPosition]
    return fullDate


def getEndDate():
    try:
        f = open(home + "/.ethereum/peers.txt", "r")
    except FileNotFoundError:
        return "-1"
    lines = f.readlines()
    endDateLine = lines[-26]
    dateStartPosition = endDateLine.find(dateYearString)
    dateEndPosition = endDateLine.find(timeZoneString)
    fullDate = endDateLine[dateStartPosition:dateEndPosition]
    return fullDate


def isEclipsed():
    try:
        f = open(home + "/.ethereum/peers.txt", "r")
    except FileNotFoundError:
        return False
    lines = f.readlines()
    if len(lines) < 26:
        return False
    lastlines = lines[-26:-1]
    if lastlines[0].startswith('===='):
        for l in lastlines[1:]:
            ipStartPosition = l.find("Address ") + 8
            ipEndPosition = l.find(":", ipStartPosition)
            ipAddr = l[ipStartPosition:ipEndPosition]
            if not any(ipAddr in s for s in ipPool):
                return False
    else:
        return False
    return True


def isReady():
    try:
        f = open(home + "/.ethereum/peers.txt", "r")
    except FileNotFoundError:
        return False
    firstline = f.readline()
    dateStartPosition = firstline.find(dateYearString)
    dateEndPosition = firstline.find(timeZoneString)
    fullDate = firstline[dateStartPosition:dateEndPosition]
    timeObj = datetime.strptime(fullDate[0:26], '%Y-%m-%d %H:%M:%S.%f')
    if datetime.now() - timeObj > timedelta(days=1):
        return True
    return False

def startAttack():
    system("sudo ufw delete deny in from 80.251.183.146")
    system("sudo ufw delete deny out to 80.251.183.146")
    system("sudo ufw delete deny in from 141.20.33.234")
    system("sudo ufw delete deny out to 141.20.33.234")

def restartGeth(count):
    system("screen -S " + screenSessionName + " -X stuff $'\003'")
    sleep(120)
    system("sudo ufw deny in from 80.251.183.146")
    system("sudo ufw deny out to 80.251.183.146")
    system("sudo ufw deny in from 141.20.33.234")
    system("sudo ufw deny out to 141.20.33.234")
    sleep(120)
    rename(
        home +
        "/.ethereum/peers.txt",
        home +
        "/.ethereum/peers_attack_churn_" +
        str(count) +
        ".txt")
    system(
        "screen -S " +
        screenSessionName +
        " -X stuff './geth --syncmode fast --verbosity 4 --nat none 1> /home/ubuntu/findnoderepls.txt 2> /home/ubuntu/gethlog'")
    system("screen -S " + screenSessionName + " -X stuff $'\015'")
    sleep(120)


def loop():
    count = 1
    while True:
        if isEclipsed():
            print(str(count) + ";" + getStartDate() + ";" + getEndDate())
            restartGeth(count)
            count = count + 1
        elif isReady():
            startAttack()
        sleep(30)


loop()
