package main

import (
	"../gethTest"

	"crypto/elliptic"
	"flag"
	"fmt"
	"os"
	"time"

	"github.com/ethereum/go-ethereum/crypto/secp256k1"
)

var (
	findNodeKeyFile string
)

func init() {
	flag.StringVar(&findNodeKeyFile, "dir", os.Getenv("HOME")+"/ethAttack/FindNodeKeys", "findNode key file")
	flag.Parse()
}

func generateFindNodeKeys() {
	fmt.Println("Generate keys...")
	timeStart := time.Now()
	k := gethTest.NewKademliaStorage(256, 1048576, 6)
	k.Fill()
	fmt.Println("... done! Duration: ", time.Since(timeStart))
	fmt.Println("Write keys to file...")
	tuples := k.GetAllTuples()
	f, _ := os.Create(findNodeKeyFile)
	for i := range tuples {
		privKey := tuples[i].Key
		privKeyHex := fmt.Sprintf("%x", privKey.D)
		pubKey := elliptic.Marshal(secp256k1.S256(), privKey.PublicKey.X, privKey.PublicKey.Y)
		pubKeyHex := fmt.Sprintf("%x", pubKey)
		f.WriteString(privKeyHex + " " + pubKeyHex + "\n")
	}
	f.Sync()
	fmt.Println("... done!")
}

func main() {
	generateFindNodeKeys()
}
